SystemOrganization addCategory: #'GRID-Example-Reports'!

GRIDReportFactory subclass: #CoursesReportFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!CoursesReportFactory classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 12:04'!
description 
	^'The rows of this report will be courses of a subject'! !

!CoursesReportFactory classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 12:03'!
nombre
	^'Courses'! !

!CoursesReportFactory classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 12:03'!
possibleCellResults 
	^OrderedCollection new
		add: CellResultForDayOfTheWeekOfACourse uniqueInstance;
		add: CellResultForPercentageOfPassingStudentsOfACourse  uniqueInstance;
		add: CellResultForAmountOfPassingStudentsOfACourse   uniqueInstance;
		yourself! !

!CoursesReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 12:06'!
groupOfReportSubjects
	^GroupOfCoursesOfASubject new! !

!CoursesReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2011 18:44'!
mandatoryReportConfigurations
	^{ConfigurationOfSubject}! !

!CoursesReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 2/14/2012 16:58'!
possibleConfigurationsForColumns
	^  {self cellResultConfigurationClass }! !

!CoursesReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 2/14/2012 16:58'!
possibleConfigurationsForReport
	^ {ConfigurationOfYear . ConfigurationOfDay . self cellResultConfigurationClass }! !

!CoursesReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/18/2012 00:55'!
reportSubjectsLabel
^' the courses '! !

GRIDReportFactory subclass: #StudentsReportFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!StudentsReportFactory classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/13/2011 21:51'!
description 
	^'The rows of this report will be students of a course'! !

!StudentsReportFactory classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/24/2011 11:40'!
nombre
	^'Students'! !

!StudentsReportFactory classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 10:31'!
possibleCellResults 
	^OrderedCollection new
		add: CellResultForNameOfStudent uniqueInstance;
		add: CellResultForGradeOfStudentInASubject uniqueInstance;
		add: CellResultForAttendanceOfStudentInASubject  uniqueInstance;
		add: CellResultForAverageGradeOfAStudent  uniqueInstance;
		add: CellResultForStudentPassing uniqueInstance;
		yourself! !

!StudentsReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/7/2011 22:19'!
groupOfReportSubjects
	^GroupOfStudentsOfACourse new! !

!StudentsReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2011 18:42'!
mandatoryReportConfigurations
	^{ConfigurationOfCourse}! !

!StudentsReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2011 18:43'!
possibleConfigurationsForReport
	^ super possibleConfigurationsForReport
				union:  {ConfigurationOfCourse . ConfigurationOfYear . ConfigurationOfDay} ! !

!StudentsReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/18/2012 00:55'!
reportSubjectsLabel
^' the students '! !

GRIDReportFactory subclass: #SubjectReportFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!SubjectReportFactory classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/13/2011 21:51'!
description 
	^'The rows of this report will be subjects'! !

!SubjectReportFactory classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 17:37'!
nombre
	^'Subjects'! !

!SubjectReportFactory classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 10:31'!
possibleCellResults 
	^OrderedCollection new
		add: CellResultForNameOfSubject uniqueInstance;
		add: CellResultForQuantityOfStudentsOfASubject uniqueInstance;
		add: CellResultForAverageOfStudentsOfASubject uniqueInstance;
		yourself! !

!SubjectReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 17:52'!
groupOfReportSubjects
	^GroupOfSubjects new! !

!SubjectReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/11/2011 18:43'!
possibleConfigurationsForReport
	^ super possibleConfigurationsForReport
				union: {ConfigurationOfCourse . ConfigurationOfYear . ConfigurationOfDay}! !

!SubjectReportFactory methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/18/2012 00:55'!
reportSubjectsLabel
^' the students '! !

TestCase subclass: #StudentReportTest
	instanceVariableNames: 'universitySubjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!StudentReportTest methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/7/2011 13:00'!
setUp

| paradigmsMonday programmingParadigms calculus1 ui algorithms students s1 s2 s3 s4 |
paradigmsMonday := Course new dayOfTheWeek:  'Monday'; year: 2011; subject: programmingParadigms. 


programmingParadigms := Subject new name: 'Programming Paradigms'; code: '082020'.
calculus1 := Subject new name: 'Calculus I'; code: '082020'.
ui := Subject new name: 'User Interfaces'; code: '082020'.
algorithms := Subject new name: 'Introduction to Algorithms'; code: '082020'.

programmingParadigms courses: (#(Monday Tuesday Wednesday Thursday Friday) collect: [:day | paradigmsMonday copy dayOfTheWeek: day ]).

calculus1 courses: (#(Monday Tuesday Wednesday Thursday Friday) collect: [:day | paradigmsMonday copy dayOfTheWeek: day; subject: calculus1 ]).

ui courses: (#(Monday Tuesday Wednesday Thursday Friday) collect: [:day | paradigmsMonday copy dayOfTheWeek:    day; subject: ui ]).

algorithms courses: (#(Monday Tuesday Wednesday Thursday Friday) collect: [:day | paradigmsMonday copy dayOfTheWeek: day; subject: algorithms ]).

"-------"

students := { (Student new fullName: 'Carla Griggio') . (Student new fullName: 'Guillermo Polito') . (Student new fullName: 'Santiago Bragagnolo') . (Student new fullName: 'Germn Leiva') . (Student new fullName: 'Dbora Fortini') . (Student new fullName: 'Nicols Passerini') . (Student new fullName: 'Mariana Matos') . (Student new fullName: 'Nicols Scarcella') . (Student new fullName: 'Guillermo Polito') . (Student new fullName: 'Alfredo Sanzo') . (Student new fullName: 'Federico Scarpa') . (Student new fullName: 'Adriel Paredes') . (Student new fullName: 'Gisela Decuzzi') } .


students  do: [:stud | 
	{programmingParadigms . calculus1 . algorithms . ui} do:[:subject | 
		(subject courseOnDay: (stud anyFreeDayOfYear:2010)) addStudent:  stud withGrade: (2 to: 10) atRandom andAttendance: ((4 to: 10)  atRandom  / 10) ]].

students.


s1 := Subject new name: 'Databases'; code: '083462'.
s2 := Subject new name: 'Calculus II'; code: '084612'.
s3 := Subject new name: 'Software Design'; code: '085634'.
s4 := Subject new name: 'Software Engineering'; code: '089633'.

{programmingParadigms . calculus1 . algorithms . ui . s1 . s2 . s3 . s4}  do:[:subject | subject courses: ( subject courses, (#(Monday Tuesday Wednesday Thursday Friday) collect: [:day |  Course new dayOfTheWeek: day; subject: subject; year:2010 ]))].

students  do: [:stud | 
	1 to: 5 do: [:num | 
	(Set with: ({programmingParadigms . calculus1 . algorithms . ui . s1 . s2 . s3 . s4} atRandom) ) do:[:subject | 
		[(subject courseOnDay: (stud anyFreeDayOfYear: 2010)) addStudent:  stud withGrade: (2 to: 10) atRandom andAttendance: ((4 to: 10)  atRandom  / 10)] on: Error do:[:error | ] ]]].

universitySubjects:= {programmingParadigms . calculus1 . algorithms . ui . s1 . s2 . s3 . s4}! !

!StudentReportTest methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 7/11/2012 10:10'!
testReportOfStudentsOfACourse
	|reportBuilder report aStudent course |
	"alumnos de un curso (da + materia) mostrando nombre, nota, asistencia, si aprob o no en un ao."
	reportBuilder := GRIDReportBuilder new.
	reportBuilder reportFactory: StudentsReportFactory new.
	reportBuilder addReportConfigurationOfClass:  ConfigurationOfCourse.
	reportBuilder addColumnConfigurationOfClass:  reportBuilder reportFactory  cellResultConfiguration. 
	reportBuilder preBuild.
	
	reportBuilder reportColumns first cellResultConfiguration cellResult: CellResultForNameOfStudent new.
	reportBuilder reportColumns second cellResultConfiguration cellResult: CellResultForGradeOfStudentInASubject new.
	reportBuilder reportColumns third cellResultConfiguration cellResult: CellResultForAttendanceOfStudentInASubject new.
	reportBuilder reportColumns fourth cellResultConfiguration cellResult: CellResultForStudentPassing new.
	
	course := universitySubjects first courses third.
	reportBuilder reportConfigurations anyOne "should be the configuration for course" configurationValue: course. 
	
	report := reportBuilder build.

	report calculate.
	
	self assert: report reportResult reportSubjects size equals: 13.
	self assert: report reportResult hasResolvedAllCellValues. 
	self assert: report hasResolvedAllCellValues. 
	self assert: report reportResult cellValues notEmpty.

	aStudent:= report reportResult reportSubjects first.

	self assert:( report reportResult cellValueForColumn: report reportColumns first andSubject: aStudent) equals: aStudent fullName.
	self assert:( report reportResult cellValueForColumn: report reportColumns second andSubject: aStudent) equals: (aStudent gradeOnCourse: course)  .
	self assert:( report reportResult cellValueForColumn: report reportColumns third andSubject: aStudent) equals: (aStudent attendanceOnCourse:  course) asFloat .
	self assert:( report reportResult cellValueForColumn: report reportColumns fourth andSubject: aStudent) equals:( aStudent passedCourse:  course) .
	
	self should:  [report reportResult cellValueForColumn: report reportColumns fourth andSubject: 5 "any not expected object"] raise: CellValueNotResolvedError .
	
	self assert: (report reportResult hasCellValueForReportSubject:  aStudent inColumn: report reportColumns  first ).
	 
! !

GRIDCellResult subclass: #CellResultForAmountOfPassingStudentsOfACourse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!CellResultForAmountOfPassingStudentsOfACourse classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 12:05'!
description
	^'Amount of passing students'! !

!CellResultForAmountOfPassingStudentsOfACourse methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 01:54'!
resultFor: aReportEvaluationContext
	^(aReportEvaluationContext valueForConcern: #course ) amountOfPassingStudents! !

GRIDCellResult subclass: #CellResultForAttendanceOfStudentInASubject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!CellResultForAttendanceOfStudentInASubject classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 16:37'!
description 
	^'% of Attendance of the Student'! !

!CellResultForAttendanceOfStudentInASubject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 10:38'!
resultFor: aReportEvaluationContext
	^((aReportEvaluationContext valueForConcern: #student) attendanceOnCourse:  (aReportEvaluationContext valueForConcern: #course)) asFloat! !

GRIDCellResult subclass: #CellResultForAverageGradeOfACourse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!CellResultForAverageGradeOfACourse methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 01:45'!
resultFor: aReportEvaluationContext
	^(aReportEvaluationContext valueForConcern: #course) averageGrade ! !

GRIDCellResult subclass: #CellResultForAverageGradeOfAStudent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!CellResultForAverageGradeOfAStudent classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 16:42'!
description 
	^'Average grade of the student'! !

!CellResultForAverageGradeOfAStudent methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 01:45'!
resultFor: aReportEvaluationContext
	^(aReportEvaluationContext valueForConcern: #student) averageGrade ! !

GRIDCellResult subclass: #CellResultForAverageOfStudentsOfASubject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!CellResultForAverageOfStudentsOfASubject classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 17:33'!
description 
	^'Average grade of students'! !

!CellResultForAverageOfStudentsOfASubject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 01:45'!
resultFor: aReportEvaluationContext
	^((aReportEvaluationContext valueForConcern: #subject) averageQuantityOfStudentsInYear:   (aReportEvaluationContext valueForConcern: #year)) asFloat! !

GRIDCellResult subclass: #CellResultForDayOfTheWeekOfACourse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!CellResultForDayOfTheWeekOfACourse classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 12:05'!
description 
	^'Day of the week'! !

!CellResultForDayOfTheWeekOfACourse methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 02:18'!
hasNumericCurrencyResult
	^false! !

!CellResultForDayOfTheWeekOfACourse methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/17/2012 19:19'!
isAggregable 
	^false! !

!CellResultForDayOfTheWeekOfACourse methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 02:18'!
resultFor: aReportEvaluationContext
	^(aReportEvaluationContext valueForConcern: #course) dayOfTheWeek ! !

GRIDCellResult subclass: #CellResultForGradeOfStudentInASubject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!CellResultForGradeOfStudentInASubject classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 16:41'!
description 
	^'Grade of the student in a course'! !

!CellResultForGradeOfStudentInASubject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 01:45'!
resultFor: aReportEvaluationContext
	^(aReportEvaluationContext valueForConcern: #course) gradeForStudent:   (aReportEvaluationContext valueForConcern: #student)! !

GRIDCellResult subclass: #CellResultForNameOfStudent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!CellResultForNameOfStudent classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 16:40'!
description 
	^'Name of the student'! !

!CellResultForNameOfStudent methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/7/2011 15:22'!
hasNumericCurrencyResult
	^false! !

!CellResultForNameOfStudent methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/17/2012 19:19'!
isAggregable 
	^false! !

!CellResultForNameOfStudent methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 01:45'!
resultFor: aReportEvaluationContext
	^(aReportEvaluationContext valueForConcern: #student) fullName ! !

GRIDCellResult subclass: #CellResultForNameOfSubject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!CellResultForNameOfSubject classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 17:30'!
description 
	^'Name of the subject'! !

!CellResultForNameOfSubject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/7/2011 15:22'!
hasNumericCurrencyResult
	^false! !

!CellResultForNameOfSubject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/17/2012 19:19'!
isAggregable 
	^false! !

!CellResultForNameOfSubject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 01:45'!
resultFor: aReportEvaluationContext
	^(aReportEvaluationContext valueForConcern: #subject) name ! !

GRIDCellResult subclass: #CellResultForPercentageOfPassingStudentsOfACourse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!CellResultForPercentageOfPassingStudentsOfACourse classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 12:05'!
description
	^'% of passing students'! !

!CellResultForPercentageOfPassingStudentsOfACourse methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 02:20'!
resultFor: aReportEvaluationContext
	^(aReportEvaluationContext valueForConcern: #course ) percentageOfPassingStudents! !

GRIDCellResult subclass: #CellResultForQuantityOfStudentsOfASubject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!CellResultForQuantityOfStudentsOfASubject classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 17:36'!
description
	^'Amount of students'! !

!CellResultForQuantityOfStudentsOfASubject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 01:45'!
resultFor: aReportEvaluationContext
	^(aReportEvaluationContext valueForConcern: #subject ) studentsCountInYear: (aReportEvaluationContext valueForConcern: #year)! !

GRIDCellResult subclass: #CellResultForStudentPassing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!CellResultForStudentPassing classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 10:32'!
description 
	^'Passing Mark'! !

!CellResultForStudentPassing methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/7/2011 15:22'!
hasNumericCurrencyResult
	^false! !

!CellResultForStudentPassing methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 10:34'!
resultFor: aGRIDReportData 
	^(aGRIDReportData valueForConcern: #student) passingMarkForCourse: ( aGRIDReportData  valueForConcern: #course)! !

GRIDReportConfiguration subclass: #ConfigurationOfCourse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!ConfigurationOfCourse classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/13/2011 21:51'!
description 
	^'Course (Subject + Day + Year)'! !

!ConfigurationOfCourse methodsFor: 'evaluacion' stamp: 'carlaGriggio 11/1/2011 16:05'!
configurationAspect
	^#course! !

!ConfigurationOfCourse methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/14/2011 20:52'!
courses
	^ (UniversitySubjects collect:[:subject | subject courses]) concatenation! !

!ConfigurationOfCourse methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 09:31'!
formInput 
|campo|
	campo:=(GRIDFMCombobox 
		label: 'Course'
		description: '' 
		on: #configurationValue  
		of: self )
			list: self courses;
			labels:[:s | s ifNotNil:[s code]].
	^campo! !

!ConfigurationOfCourse methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/7/2011 23:43'!
orderInReportTitle
	^3! !

!ConfigurationOfCourse methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/1/2011 15:49'!
titleInReport
	^self configurationValue subject name, ' (', self configurationValue dayOfTheWeek ,') ', self configurationValue year asString! !

GRIDReportConfiguration subclass: #ConfigurationOfDay
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!ConfigurationOfDay classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/13/2011 21:51'!
description 
	^'Day of the Week'! !

!ConfigurationOfDay methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/1/2011 16:06'!
configurationAspect
	^#day! !

!ConfigurationOfDay methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 09:30'!
formInput 
|campo|
	campo:=(GRIDFMCombobox 
		label: 'Day'
		description: '' 
		on: #configurationValue  
		of: self )
			list: #(Monday Tuesday Wednesday Thursday Friday).
	^campo! !

!ConfigurationOfDay methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/24/2011 14:33'!
orderInReportTitle
	^3! !

!ConfigurationOfDay methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/1/2011 16:54'!
titleInReport
	^self configurationValue displayString ! !

GRIDReportConfiguration subclass: #ConfigurationOfSubject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!ConfigurationOfSubject classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/13/2011 21:51'!
description 
	^'Subject'! !

!ConfigurationOfSubject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/1/2011 16:06'!
configurationAspect
	^#subject! !

!ConfigurationOfSubject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 09:30'!
formInput 
	^(GRIDFMCombobox 
		label: 'Subject'
		description: '' 
		on: #configurationValue  
		of: self )
			list: UniversitySubjects;
			labels:[:s | s ifNotNil:[s name]].! !

!ConfigurationOfSubject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 10:49'!
orderInReportTitle
	^2! !

!ConfigurationOfSubject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/1/2011 15:51'!
titleInReport
	^self configurationValue name! !

GRIDReportConfiguration subclass: #ConfigurationOfYear
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!ConfigurationOfYear classSide methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/13/2011 21:51'!
description 
	^'Year'! !

!ConfigurationOfYear methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/1/2011 16:06'!
configurationAspect
	^#year! !

!ConfigurationOfYear methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 09:30'!
formInput 
|campo|
	campo:=(GRIDFMCombobox 
		label: 'Year'
		description: '' 
		on: #configurationValue  
		of: self )
			list: #(2010 2011).
	^campo! !

!ConfigurationOfYear methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/25/2011 17:45'!
orderInReportTitle
	^3! !

!ConfigurationOfYear methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/1/2011 16:06'!
titleInReport
	^self configurationValue displayString ! !

!ConfigurationOfYear methodsFor: 'accessing' stamp: 'carlaGriggio 10/13/2011 16:09'!
year
	^ year! !

!ConfigurationOfYear methodsFor: 'accessing' stamp: 'carlaGriggio 10/13/2011 16:09'!
year: anObject
	year := anObject! !

GRIDGroupOfReportSubjects subclass: #GroupOfCoursesOfASubject
	instanceVariableNames: 'subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!GroupOfCoursesOfASubject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/21/2011 15:36'!
allReportSubjects
	^(self reportEvaluationContext valueForConcern: #subject) courses! !

!GroupOfCoursesOfASubject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 12:40'!
configurationAspect
	^#course! !

!GroupOfCoursesOfASubject methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 1/18/2012 00:47'!
configureContextForSubject:  aSubject 
	^self reportEvaluationContext valueForConcern: #course is: aSubject  ! !

!GroupOfCoursesOfASubject methodsFor: 'accessing' stamp: 'carlaGriggio 8/7/2011 21:56'!
subject
	^ subject! !

!GroupOfCoursesOfASubject methodsFor: 'accessing' stamp: 'carlaGriggio 8/7/2011 21:56'!
subject: anObject
	subject := anObject! !

GRIDGroupOfReportSubjects subclass: #GroupOfStudentsOfACourse
	instanceVariableNames: 'course'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!GroupOfStudentsOfACourse methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/21/2011 15:37'!
allReportSubjects
	^(self reportEvaluationContext valueForConcern: #course) students! !

!GroupOfStudentsOfACourse methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 09:21'!
configureContextForSubject: anEvaluationSubject 
	self reportEvaluationContext valueForConcern: #student is: anEvaluationSubject ! !

GRIDGroupOfReportSubjects subclass: #GroupOfSubjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GRID-Example-Reports'!

!GroupOfSubjects methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/21/2011 15:37'!
allReportSubjects
	^ UniversitySubjects ! !

!GroupOfSubjects methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/3/2011 09:21'!
configureContextForSubject: anEvaluationSubject 
	self reportEvaluationContext valueForConcern: #subject is: anEvaluationSubject ! !
